var jPhidget22 = require('phidget22');

var SERVER_PORT = 5661;

function main() {

	if (process.argv.length != 3) {
		console.log('usage: node GPS.js <server address>');
		process.exit(1);
	}

	var url = 'phid://' + process.argv[2] + ':' + SERVER_PORT;

	console.log('connecting to:' + url);
	var conn = new jPhidget22.Connection(url, { name: 'Server Connection', passwd: '' });
	conn.connect()
	  .then(runExample)
	  .catch(function (err) {
	  	console.log('Error running example:' + err);
		process.exit(1);
	  });
}

function runExample() {

	console.log('connected to server');
	var ch = new jPhidget22.GPS();

	ch.onAttach = function(ch) {
		console.log(ch + ' attached');
	};

	ch.onDetach = function(ch) {
		console.log(ch + ' detached');
	};

	ch.onPositionChange = function (latitude, longitude, altitude) {
        console.log('latitude:' + latitude + ' (' + this.getLatitude() + ')');
		console.log('longitude:' + longitude + ' (' + this.getLongitude() + ')');
		console.log('altitude:' + altitude + ' (' + this.getAltitude() + ')');
		console.log();
	};
	
	ch.onHeadingChange = function(heading, velocity) {
		console.log('heading:' + heading + ' (' + this.getHeading() + ')');
		console.log('velocity:' + velocity + ' (' + this.getVelocity() + ')');
		console.log();
	};

	ch.open().then(function (ch) {
		console.log('channel open');
	}).catch(function (err) {
		console.log('failed to open the channel:' + err);
	});
}

if (require.main === module)
	main();
